#
# Conditional build:
%bcond_without	gstreamer	# GStreamer-based video support
%bcond_without	js		# JavaScript support
%bcond_with	pdf		# PDF export and GTK+ printing support via libharu [needs update?]
%bcond_without	webp		# WebP image support
#
Summary:	Light WWW browser with CSS support
Summary(pl.UTF-8):	Lekka przeglądarka WWW z obsługą CSS
Name:		netsurf
Version:	3.9
Release:	1
License:	GPL v2 with OpenSSL exception (code), MIT (artwork)
Group:		Applications/Networking
Source0:	http://download.netsurf-browser.org/netsurf/releases/source/%{name}-%{version}-src.tar.gz
# Source0-md5:	9262e5c2005c08281fce7596cf80e165
Source1:	%{name}.desktop
Patch0:		nsfb-ldflags.patch
Patch1:		%{name}-link.patch
Patch3:		optflags.patch
Patch4:		fixes.patch
Patch5:		%{name}-utf8proc.patch
URL:		http://netsurf-browser.org/
BuildRequires:	curl-devel
BuildRequires:	freetype-devel >= 2
%{?with_gstreamer:BuildRequires:	gstreamer0.10-devel >= 0.10}
BuildRequires:	gtk+2-devel >= 2.0
BuildRequires:	libCSS-devel >= 0.9.0
BuildRequires:	libdom-devel >= 0.4.0
%{?with_pdf:BuildRequires:	libharu-devel}
BuildRequires:	libhubbub-devel >= 0.3.6
BuildRequires:	libjpeg-devel
BuildRequires:	libnsbmp-devel >= 0.1.5
BuildRequires:	libnsfb-devel >= 0.2.1
BuildRequires:	libnsgif-devel >= 0.2.1
BuildRequires:	libnslog-devel >= 0.1.2
BuildRequires:	libnspsl-devel >= 0.1.5
BuildRequires:	libnsutils-devel >= 0.0.5
BuildRequires:	libparserutils-devel >= 0.2.4
BuildRequires:	libpng-devel
BuildRequires:	librsvg-devel
BuildRequires:	libsvgtiny-devel >= 0.1.7
BuildRequires:	libutf8proc-devel >= 2.4.0
BuildRequires:	libwapcaplet-devel >= 0.4.2
%{?with_webp:BuildRequires:	libwebp-devel}
BuildRequires:	openssl-devel
BuildRequires:	netsurf-buildsystem >= 1.8
BuildRequires:	nsgenbind >= 0.7
BuildRequires:	perl-HTML-Parser
BuildRequires:	pkgconfig
BuildRequires:	sed >= 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

%description -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

%package common
Summary:	NetSurf - common files
Summary(pl.UTF-8):	NetSurf - pliki wspólne
Group:		Applications/Networking

%description common
NetSurf - common files.

%description common -l pl.UTF-8
NetSurf - wspólne pliki.

%package gtk
Summary:	NetSurf web browser - GTK+ version
Summary(pl.UTF-8):	Wersja GTK+ przeglądarki WWW NetSurf
Group:		Applications/Networking
Requires:	%{name}-common = %{version}-%{release}
Requires:	libCSS >= 0.9.0
Requires:	libdom >= 0.4.0
Requires:	libhubbub >= 0.3.6
Requires:	libnsbmp >= 0.1.5
Requires:	libnsgif >= 0.2.1
Requires:	libnspsl >= 0.1.5
Requires:	libparserutils >= 0.2.4
Requires:	libsvgtiny >= 0.1.7
Requires:	libutf8proc >= 2.4.0
Requires:	libwapcaplet >= 0.4.2

%description gtk
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

This package contains GTK+ version.

%description gtk -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

Ten pakiet zawiera wersję GTK+.

%package sdl
Summary:	NetSurf web browser - SDL (framebuffer aware) version
Summary(pl.UTF-8):	Wersja SDL (obsługująca framebuffer) przeglądarki WWW NetSurf
Group:		Applications/Networking
Requires:	%{name}-common = %{version}-%{release}
Requires:	libCSS >= 0.9.0
Requires:	libdom >= 0.4.0
Requires:	libhubbub >= 0.3.6
Requires:	libnsbmp >= 0.1.5
Requires:	libnsfb >= 0.2.1
Requires:	libnsgif >= 0.2.1
Requires:	libnspsl >= 0.1.5
Requires:	libparserutils >= 0.2.4
Requires:	libsvgtiny >= 0.1.7
Requires:	libutf8proc >= 2.4.0
Requires:	libwapcaplet >= 0.4.2
Suggests:	fonts-TTF-DejaVu

%description sdl
NetSurf is a multi-platform lightweight web browser. Its aim is to
provide comprehensive rendering of HTML 5 with CSS 2 in a small
resource footprint while remaining fast.

This package contains SDL, framebuffer aware version.

%description sdl -l pl.UTF-8
NetSurf to wieloplatformowa, lekka przeglądarka WWW. Celem jest
zapewnienie kompletnego renderowania HTML 5 z CSS 2 przy małym
wykorzystanie zasobów, z zachowaniem dużej szybkości.

Ten pakiet zawiera wersję SDL, obsługującą framebuffer.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

cat << EOF > Makefile.config
NETSURF_FB_FONTLIB := freetype
NETSURF_FB_FONTPATH := %{_datadir}/fonts/TTF
NETSURF_USE_NSSVG := YES
NETSURF_USE_RSVG := YES
%{?with_webp:NETSURF_USE_WEBP := YES}
%{?with_gstreamer:NETSURF_USE_VIDEO := YES}
%{?with_pdf:NETSURF_USE_HARU_PDF := YES}
EOF

%if %{with gstreamer}
# GStreamer 0.10 uses now deprecated glib mutex APIs
%{__sed} -i -e '/-DG_DISABLE_DEPRECATED/d' frontends/gtk/Makefile
%endif
# gdk-pixbuf 2.31 deprecates GdkPixdata
%{__sed} -i -e '/-DGDK_PIXBUF_DISABLE_DEPRECATED/d' frontends/gtk/Makefile

%build
export CC="%{__cc}"
# while cxx not needed, somewhy it helps race condition on carme build
export CXX="%{__cxx}"
# silence -Werror:
#src/surface/vnc.c: In function 'vnc_input':
#src/surface/vnc.c:489:9: error: variable 'ret' set but not used [-Werror=unused-but-set-variable]
export CFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE"
export CXXFLAGS="%{rpmcxxflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE"
export LDFLAGS="%{rpmldflags}"

# make -j1 or it won't find libwapcaplet/libwapcaplet.h

%{__make} \
	OPTFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE" \
	OPTLDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	Q='' \
	TARGET=gtk

%{__make} \
	OPTFLAGS="%{rpmcflags} -Wno-error=unused-but-set-variable -D_GNU_SOURCE" \
	OPTLDFLAGS="%{rpmldflags}" \
	PREFIX=%{_prefix} \
	Q='' \
	TARGET=framebuffer

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	Q='' \
	PREFIX=%{_prefix} \
	TARGET=gtk \
	DESTDIR=$RPM_BUILD_ROOT


%{__make} install \
	Q='' \
	PREFIX=%{_prefix} \
	TARGET=framebuffer \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir}}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}

# compatibility with older PLD packages
ln -sf netsurf-fb $RPM_BUILD_ROOT%{_bindir}/nsfb
ln -sf netsurf-gtk $RPM_BUILD_ROOT%{_bindir}/nsgtk

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(644,root,root,755)
%doc COPYING README
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/Messages
%{_datadir}/%{name}/SearchEngines
%{_datadir}/%{name}/default.ico
%{_datadir}/%{name}/languages
%{_datadir}/%{name}/*.css
%{_datadir}/%{name}/*.html
%{_datadir}/%{name}/*.png
%{_datadir}/%{name}/*.txt
%{_datadir}/%{name}/*.xpm
%{_datadir}/%{name}/icons
%{_datadir}/%{name}/throbber
%lang(de) %{_datadir}/%{name}/de
%{_datadir}/%{name}/en
%lang(fr) %{_datadir}/%{name}/fr
%lang(it) %{_datadir}/%{name}/it
%lang(ja) %{_datadir}/%{name}/ja
%lang(nl) %{_datadir}/%{name}/nl

%files gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/netsurf-gtk
%attr(755,root,root) %{_bindir}/nsgtk
%{_datadir}/%{name}/*.gtk2.ui
%{_desktopdir}/netsurf.desktop

%files sdl
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/netsurf-fb
%attr(755,root,root) %{_bindir}/nsfb
%changelog
* Sat Nov 30 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/netsurf.git;a=log;h=master

* Sat Nov 30 2019 Jakub Bogusz <qboosh@pld-linux.org> 958c626
- updated to 3.9

* Sat Dec 29 2018 Jakub Bogusz <qboosh@pld-linux.org> 491b224
- updated to 3.8
- updated utf8proc patch

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 042406c
- release 2 (by relup.sh)

* Fri Jul 13 2018 Jakub Bogusz <qboosh@pld-linux.org> 2cb0de4
- added utf8proc (adjust for header move in libutf8proc package)

* Tue Feb 13 2018 Witold Filipczyk <witekfl@poczta.onet.pl> 9793be2
- BR: nsgenbind >= 0.5

* Mon Oct 30 2017 Witold Filipczyk <witekfl@poczta.onet.pl> f87373d
- updated netsurf-link.patch
- updated to 3.7

* Fri Nov 25 2016 Jakub Bogusz <qboosh@pld-linux.org> a4f8eeb
- rely on make install with binaries (+old packages compatibility)
- moved gtk-specific data files to -gtk; mark localized messages with lang()

* Mon Nov 21 2016 Witold Filipczyk <witekfl@poczta.onet.pl> 128c42b
- updated to 3.6
- some changes in patches

* Thu Apr 14 2016 Witold Filipczyk <witekfl@poczta.onet.pl> 7d2db20
- updated to 3.5

* Sat Feb 27 2016 Witold Filipczyk <witekfl@poczta.onet.pl> 5d4a780
- DejaVu is required by nsfb on start, but probably might be changed in configuration

* Sat Feb 27 2016 Witold Filipczyk <witekfl@poczta.onet.pl> b2fbd8e
- updated to 3.4
- javascript is "provided" by duktape

* Sun Jan 03 2016 Jan Rękorajski <baggins@pld-linux.org> 3ecc302
- release 2 (by relup.sh)

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 94e17ef
- more js187 fixes

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> 0b77bda
- update js version in Makefile

* Sun Aug 09 2015 Jan Rękorajski <baggins@pld-linux.org> f37fbad
- bump js req to 187

* Mon Mar 16 2015 Witold Filipczyk <witekfl@poczta.onet.pl> 19c141f
- updated to 3.3
- added jsapi_h.patch

* Tue Dec 02 2014 Jakub Bogusz <qboosh@pld-linux.org> 5a1b122
- fixed build with gdk-pixbuf 2.31.x
- libglade no longer needed

* Mon Dec 01 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 3df4878
- bcond js. Javascript support is very poor
- increased the nsgenbind version number in BR.

* Mon Dec 01 2014 Witold Filipczyk <witekfl@poczta.onet.pl> 5eeba20
- updated to 3.2
- disabled xulrunner, enabled js185

* Tue Nov 25 2014 Jan Rękorajski <baggins@pld-linux.org> 0bb73e3
- fix passing CFLAGS/LDFLAGS
- rel 3

